#ifndef WINAMP3_MAIN_H
#define WINAMP3_MAIN_H

//include the WasabiSDK/studio in your project settings for these to be valid...
#include "common/contwnd.h"
#include "common/listwnd.h"
#include "studio/consolecb.h"
#include "studio/corecb.h"

#include <qapplication.h>

// Forward references
class ButtonWnd;
class Winamp3;
class LPFactory;
class LogWA;
class LPFacade;

//#define CALLBACKWND_PARENT ListWnd
#define CALLBACKWND_PARENT ContWnd

class CallbackWnd : public CALLBACKWND_PARENT, public QObject {
public:

  //
  // These are the ID values that we give to our
  // buttons in order to know what the fudget got
  // pushed when we get told something got pushed.
  typedef enum {
    LP_FRAMEBUTTON1 = 5,
    LP_PLSELECT = 10
    //
//    NUM_EXB_NOTIFY
  } LongPlayerWindowNotifyIDs;

  CallbackWnd();
  virtual ~CallbackWnd();
  virtual bool event(QEvent*);

  //init things that require an api->
  virtual int onInit();
  //this actually does not work, only the WAComponentClient class has this :(
  virtual void onDestroy();

  virtual int childNotify(RootWnd *which, int msg, int param1, int param2);


  // =========================================================================
  //
  //  Methods required by Window Creation Services
  //
  static const char *getWindowTypeName();
  static GUID getWindowTypeGuid();
  static void setIconBitmaps(ButtonWnd *button);

  // Output the String
  virtual int corecb_outputString(const char *string);

	Winamp3* _amp;
	LPFactory* _fac;
    LogWA* _logger;
	ListWnd* _list; //debugging output
	ListWnd* _playlists; //debugging output
	LPFacade* _facade;
};

#endif
